
CoCoALib - Bug #834

Fix test failures (after revising MatrixForOrdering)

09 Dec 2015 13:40 - John Abbott

Status: Closed Start date: 09 Dec 2015

Priority: Normal Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Tidying Estimated time: 0.00 hour

Target version: CoCoALib-0.99540 Feb 2016 Spent time: 2.25 hours

Description

The current CVS produces 3 failed CoCoALib tests:

test-MatrixForOrdering1, test-RingWeyl1, test-SparsePolyRing1

and 2 failed examples:

ex-RingWeyl2, ex-RingWeyl3

The following CoCoA-5 tests failed too:

demo-Osaka2015.cocoa5 primary.cocoa5 lecture-HF1.cocoa5 lecture-HF4.cocoa5 radical.cocoa5 SourceAnna.cocoa5

Compilation with debugging activated produced 7 failed tests:

test-GOperations1, test-GOperations2, test-MatrixForOrdering1, test-QuotientRing1, test-RingWeyl1, test-SparsePolyRing1,

test-TmpMorseGraph

and 4 failed examples:

ex-module2 ex-PPMonoidElem2 ex-RingWeyl2 ex-RingWeyl3

Related issues:

Related to CoCoALib - Design #827: NewPositiveMat also for matrices over QQ? ... Closed 26 Nov 2015

Related to CoCoALib - Bug #820: NewMatMinimize, NewMatCompleteOrd - a godfors... Closed 25 Nov 2015

History

#1 - 09 Dec 2015 13:41 - John Abbott

JAA believes the root cause is the check that a grading is strictly positive when weakly positive is sufficient.

#2 - 09 Dec 2015 22:08 - Anna Maria Bigatti

- Status changed from New to In Progress

- Assignee set to Anna Maria Bigatti

- % Done changed from 0 to 10

First bug trapped:

IsPositiveOrd wants rk(M) == NumRows(M).

This function is called when making a term ordering out of a possibly redundant matrix.  Obviously incompatible

(Failure in test-SparsePolyRing1)

I think the check on the columns should be an independent function called by IsPositiveOrd which will also do the extra check on the rank.

.. Need to find a good name for it...

#3 - 10 Dec 2015 10:17 - John Abbott

I have just checked in a modified version of MatrixForOrdering.C following Anna's suggestion in comment 2.

Now "only" 5 tests fail (with debugging on).

I have added a new fn called ColCheck; I think its interface is reasonable, but I am not happy with its name.

I note that MatrixForOrdering.C still contains a lot of cruft :-/
#4 - 10 Dec 2015 13:11 - Anna Maria Bigatti

lines 304 and following (#ifdef) in PPOrdering.C should be deleted:

we do non require to have a PositiveGrading for making an ordering.  It is only necessary if we want to compute a Hilbert Series.  (the check should

be there... maybe it isn't... yet)

#5 - 10 Dec 2015 14:36 - Anna Maria Bigatti

- % Done changed from 10 to 20

I'm writing another function HasNegEntry which checks whether there is a negative entry.

(then we can think of a better name ;-)

#6 - 10 Dec 2015 15:03 - Anna Maria Bigatti

I'm also writing IsUpperTriangular.

Addendum (JAA) also IsLowerTriangular?  Will these go into a "matrix" source file?

#7 - 10 Dec 2015 15:04 - Anna Maria Bigatti

- Subject changed from Fix test failures (after revising MatrixFroOrdering) to Fix test failures (after revising MatrixForOrdering)

#8 - 10 Dec 2015 15:59 - John Abbott

- % Done changed from 20 to 10

Ignoring the question of the name for ColCheck, is it better to have a single fn with a flag to say whether or not to allow zero cols, or is it better to have

2 fns (with similar names) one allowing zero cols and the other not?

The current situation is a single fn with a "flag", so a call looks like this:

  matrix M;

  ...

  if (ColCheck(M, WithoutZeroCol)) ...

  ...

  if (ColCheck(M, PossiblyWithZeroCol)) ...

 

The alternative would look something like this:

  matrix M;

  ...

  if (ColCheckWithoutZeroCol(M)) ...

  ...

  if (ColCheckWithZeroCol(M)) ...

 

Not sure which I prefer.  It would be nice to have a general guideline, but that may be difficult to achieve universally.

Comments?  Ideas?  Criticisms?
#9 - 22 Mar 2016 17:44 - Anna Maria Bigatti

I think there are no more failures now.  Close this issue?

#10 - 24 Mar 2016 11:42 - Anna Maria Bigatti

- Status changed from In Progress to Closed

- % Done changed from 10 to 100

All tests pass (no idea how long we have spent on this).  Closing.

John Abbott wrote:

Ignoring the question of the name for ColCheck, is it better to have a single fn with a flag to say whether or not to allow zero cols, or is it better to

have 2 fns (with similar names) one allowing zero cols and the other not?

 

OK with the flag.
